diff --git a/app/controllers/autosign_controller.rb b/app/controllers/autosign_controller.rb
index f4137149d..ac205eec3 100644
--- a/app/controllers/autosign_controller.rb
+++ b/app/controllers/autosign_controller.rb
@@ -1,7 +1,9 @@
 class AutosignController < ApplicationController
-  before_filter :find_proxy, :setup_proxy
 
   def index
+    @proxy = SmartProxy.authorized(:view_smart_proxies_autosign).find(params[:smart_proxy_id])
+    setup_proxy
+
     begin
       autosign = @api.autosign
     rescue => e
@@ -12,9 +14,14 @@ class AutosignController < ApplicationController
   end
 
   def new
+    @proxy = SmartProxy.authorized(:create_smart_proxies_autosign).find(params[:smart_proxy_id])
+    setup_proxy
   end
 
   def create
+    @proxy = SmartProxy.authorized(:create_smart_proxies_autosign).find(params[:smart_proxy_id])
+    setup_proxy
+
     if @api.set_autosign(params[:id])
       process_success({:success_redirect => smart_proxy_autosign_index_path(@proxy), :object_name => 'puppet autosign entry'})
     else
@@ -23,6 +30,9 @@ class AutosignController < ApplicationController
   end
 
   def destroy
+    @proxy = SmartProxy.authorized(:destroy_smart_proxies_autosign).find(params[:smart_proxy_id])
+    setup_proxy
+
     if @api.del_autosign(params[:id])
       process_success({:success_redirect => smart_proxy_autosign_index_path(@proxy), :object_name => 'puppet autosign entry'})
     else
@@ -32,10 +42,6 @@ class AutosignController < ApplicationController
 
   private
 
-  def find_proxy
-    @proxy = SmartProxy.find(params[:smart_proxy_id])
-  end
-
   def setup_proxy
     @api = ProxyAPI::Puppetca.new({:url => @proxy.url})
   end
diff --git a/app/controllers/bookmarks_controller.rb b/app/controllers/bookmarks_controller.rb
index ad08ec425..58f7f1db3 100644
--- a/app/controllers/bookmarks_controller.rb
+++ b/app/controllers/bookmarks_controller.rb
@@ -2,7 +2,7 @@ class BookmarksController < ApplicationController
   before_filter :find_by_name, :only => %w{show edit update destroy}
 
   def index
-    @bookmarks = Bookmark.paginate(:page => params[:page])
+    @bookmarks = resource_base.paginate(:page => params[:page])
   end
 
   def new
diff --git a/app/controllers/common_parameters_controller.rb b/app/controllers/common_parameters_controller.rb
index 51e819336..72bc99df2 100644
--- a/app/controllers/common_parameters_controller.rb
+++ b/app/controllers/common_parameters_controller.rb
@@ -1,8 +1,9 @@
 class CommonParametersController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
 
   def index
-    @common_parameters = CommonParameter.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @common_parameters = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
   end
 
   def new
@@ -19,11 +20,9 @@ class CommonParametersController < ApplicationController
   end
 
   def edit
-    @common_parameter = CommonParameter.find(params[:id])
   end
 
   def update
-    @common_parameter = CommonParameter.find(params[:id])
     if @common_parameter.update_attributes(params[:common_parameter])
       process_success
     else
@@ -32,11 +31,20 @@ class CommonParametersController < ApplicationController
   end
 
   def destroy
-    @common_parameter = CommonParameter.find(params[:id])
     if @common_parameter.destroy
       process_success
     else
       process_error
     end
   end
+
+  private
+
+  def controller_permission
+    'globals'
+  end
+
+  def resource_base
+    model_of_controller.authorized(current_permission, CommonParameter)
+  end
 end
diff --git a/app/controllers/compute_profiles_controller.rb b/app/controllers/compute_profiles_controller.rb
index 99f689b61..252bd875f 100644
--- a/app/controllers/compute_profiles_controller.rb
+++ b/app/controllers/compute_profiles_controller.rb
@@ -1,10 +1,9 @@
 class ComputeProfilesController < ApplicationController
-
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_compute_profile, :only => %w{edit show update destroy}
+  before_filter :find_by_name, :only => [:show, :edit, :update, :destroy]
 
   def index
-    @compute_profiles = ComputeProfile.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @compute_profiles = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
   end
 
   def show
@@ -42,10 +41,5 @@ class ComputeProfilesController < ApplicationController
     end
   end
 
-  private
-
-  def find_compute_profile
-    @compute_profile = ComputeProfile.find(params[:id])
-  end
 
 end
diff --git a/app/controllers/compute_resources_controller.rb b/app/controllers/compute_resources_controller.rb
index c35170697..17352c5c6 100644
--- a/app/controllers/compute_resources_controller.rb
+++ b/app/controllers/compute_resources_controller.rb
@@ -2,10 +2,10 @@ class ComputeResourcesController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
   AJAX_REQUESTS = %w{template_selected cluster_selected}
   before_filter :ajax_request, :only => AJAX_REQUESTS
-  before_filter :find_by_id, :only => [:show, :edit, :update, :destroy, :ping, :associate] + AJAX_REQUESTS
+  before_filter :find_by_name, :only => [:show, :edit, :associate, :update, :destroy, :ping] + AJAX_REQUESTS
 
   def index
-    @compute_resources = ComputeResource.my_compute_resources.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @compute_resources = resource_base.search_for(params[:search], :order => params[:order]).paginate :page => params[:page]
   end
 
   def new
@@ -86,7 +86,7 @@ class ComputeResourcesController < ApplicationController
     # cr_id is posted from AJAX function. cr_id is nil if new
     Rails.logger.info "CR_ID IS #{params[:cr_id]}"
     if params[:cr_id].present? && params[:cr_id] != 'null'
-      @compute_resource = ComputeResource.find(params[:cr_id])
+      @compute_resource = ComputeResource.authorized(:edit_compute_resources).find(params[:cr_id])
       params[:compute_resource].delete(:password) if params[:compute_resource][:password].blank?
       @compute_resource.attributes = params[:compute_resource]
     else
@@ -112,9 +112,14 @@ class ComputeResourcesController < ApplicationController
 
   private
 
-  def find_by_id
-    @compute_resource = ComputeResource.find(params[:id])
-    not_found and return unless @compute_resource
-    deny_access and return unless ComputeResource.my_compute_resources.include?(@compute_resource)
+  def action_permission
+    case params[:action]
+      when 'associate'
+        'edit'
+      when 'ping', 'template_selected', 'cluster_selected'
+        'view'
+      else
+        super
+    end
   end
 end
diff --git a/app/controllers/compute_resources_vms_controller.rb b/app/controllers/compute_resources_vms_controller.rb
index 0e5fa6c6e..658f3dffd 100644
--- a/app/controllers/compute_resources_vms_controller.rb
+++ b/app/controllers/compute_resources_vms_controller.rb
@@ -1,9 +1,9 @@
 class ComputeResourcesVmsController < ApplicationController
-  before_filter :find_compute_resource
-  before_filter :find_vm, :only => [:show, :power, :pause, :console, :associate]
 
   def index
+    @compute_resource = find_compute_resource(:view_compute_resources_vms)
     @vms = @compute_resource.vms.all(params[:filters] || {})
+    @authorizer = Authorizer.new(User.current, :collection => [@compute_resource])
     respond_to do |format|
       format.html
       format.json { render :json => @vms }
@@ -13,10 +13,12 @@ class ComputeResourcesVmsController < ApplicationController
   end
 
   def new
+    @compute_resource = find_compute_resource
     @vm = @compute_resource.new_vm
   end
 
   def create
+    @compute_resource = find_compute_resource
     if @compute_resource.create_vm params[:vm]
       process_success :success_redirect => compute_resource_vms_path(@compute_resource)
     else
@@ -25,6 +27,8 @@ class ComputeResourcesVmsController < ApplicationController
   end
 
   def associate
+    @compute_resource = find_compute_resource(:edit_compute_resources)
+    @vm = find_vm
     if Host.where(:uuid => @vm.identity).any?
       process_error(:error_msg => _("VM already associated with a host"), :redirect => compute_resource_vm_path(:compute_resource_id => params[:compute_resource_id], :id => @vm.identity))
     else
@@ -41,6 +45,8 @@ class ComputeResourcesVmsController < ApplicationController
   end
 
   def show
+    @compute_resource = find_compute_resource(:view_compute_resources_vms)
+    @vm = find_vm
     respond_to do |format|
       format.html
       format.json { render :json => @vm }
@@ -48,14 +54,19 @@ class ComputeResourcesVmsController < ApplicationController
   end
 
   def power
+    @compute_resource = find_compute_resource(:power_compute_resources_vms)
+    @vm = find_vm
     run_vm_action(@vm.ready? ? :stop : :start)
   end
 
   def pause
+    @compute_resource = find_compute_resource(:power_compute_resources_vms)
+    @vm = find_vm
     run_vm_action(@vm.ready? ? :pause : :start)
   end
 
   def destroy
+    @compute_resource = find_compute_resource(:destroy_compute_resources_vms)
     if @compute_resource.destroy_vm params[:id]
       process_success({ :success_redirect => compute_resource_vms_path(@compute_resource) })
     else
@@ -64,6 +75,8 @@ class ComputeResourcesVmsController < ApplicationController
   end
 
   def console
+    @compute_resource = find_compute_resource(:console_compute_resources_vms)
+    @vm = find_vm
     @console = @compute_resource.console @vm.identity
     render case @console[:type]
              when 'spice'
@@ -79,13 +92,12 @@ class ComputeResourcesVmsController < ApplicationController
 
   private
 
-  def find_compute_resource
-    @compute_resource = ComputeResource.find(params[:compute_resource_id])
-    @compute_resource = ComputeResource.my_compute_resources.find(params[:compute_resource_id]) rescue deny_access
+  def find_compute_resource(permission = :view_compute_resources)
+    ComputeResource.authorized(permission).find(params[:compute_resource_id])
   end
 
   def find_vm
-    @vm = @compute_resource.find_vm_by_uuid params[:id]
+    @compute_resource.find_vm_by_uuid params[:id]
   end
 
   def run_vm_action(action)
diff --git a/app/controllers/concerns/api/import_puppetclasses_common_controller.rb b/app/controllers/concerns/api/import_puppetclasses_common_controller.rb
index 19225dc9a..c8ac305e4 100644
--- a/app/controllers/concerns/api/import_puppetclasses_common_controller.rb
+++ b/app/controllers/concerns/api/import_puppetclasses_common_controller.rb
@@ -90,8 +90,8 @@ module Api::ImportPuppetclassesCommonController
 
   def find_required_puppet_proxy
     id = params.keys.include?('smart_proxy_id') ? params['smart_proxy_id'] : params['id']
-    @smart_proxy   = SmartProxy.find_by_id(id.to_i) if id.to_i > 0
-    @smart_proxy ||= SmartProxy.find_by_name(id)
+    @smart_proxy   = SmartProxy.authorized(:view_smart_proxies).find_by_id(id.to_i) if id.to_i > 0
+    @smart_proxy ||= SmartProxy.authorized(:view_smart_proxies).find_by_name(id)
     unless @smart_proxy && SmartProxy.puppet_proxies.pluck("smart_proxies.id").include?(@smart_proxy.id)
       not_found 'We did not find a foreman proxy that can provide the information, ensure that this proxy has the puppet feature turned on.'
     end
@@ -108,8 +108,8 @@ module Api::ImportPuppetclassesCommonController
   end
 
   def find_optional_environment
-    @environment   = Environment.find_by_id(@env_id.to_i) if @env_id.to_i > 0
-    @environment ||= Environment.find_by_name(@env_id)
+    @environment   = Environment.authorized(:view_environments).find_by_id(@env_id.to_i) if @env_id.to_i > 0
+    @environment ||= Environment.authorized(:view_environments).find_by_name(@env_id)
     @environment
   end
 
diff --git a/app/controllers/concerns/api/v2/lookup_keys_common_controller.rb b/app/controllers/concerns/api/v2/lookup_keys_common_controller.rb
index ed491ecba..ce4a679dc 100644
--- a/app/controllers/concerns/api/v2/lookup_keys_common_controller.rb
+++ b/app/controllers/concerns/api/v2/lookup_keys_common_controller.rb
@@ -44,34 +44,34 @@ module Api::V2::LookupKeysCommonController
     end
 
     def find_puppetclass
-      @puppetclass   = Puppetclass.find_by_id(params['puppetclass_id'].to_i) if params['puppetclass_id'].to_i > 0
-      @puppetclass ||= Puppetclass.find_by_name(params['puppetclass_id'])
+      @puppetclass   = Puppetclass.authorized(:view_puppetclasses).find_by_id(params['puppetclass_id'].to_i) if params['puppetclass_id'].to_i > 0
+      @puppetclass ||= Puppetclass.authorized(:view_puppetclasses).find_by_name(params['puppetclass_id'])
       @puppetclass
     end
 
     def find_environment
-      @environment   = Environment.find_by_id(params['environment_id'].to_i) if params['environment_id'].to_i > 0
-      @environment ||= Environment.find_by_name(params['environment_id'])
+      @environment   = Environment.authorized(:view_environments).find_by_id(params['environment_id'].to_i) if params['environment_id'].to_i > 0
+      @environment ||= Environment.authorized(:view_environments).find_by_name(params['environment_id'])
       @environment
     end
 
     def find_host
-      @host   = Host::Base.find_by_id(params['host_id'].to_i) if params['host_id'].to_i > 0
-      @host ||= Host::Base.find_by_name(params['host_id'])
+      @host   = Host::Base.authorized(:view_hosts).find_by_id(params['host_id'].to_i) if params['host_id'].to_i > 0
+      @host ||= Host::Base.authorized(:view_hosts).find_by_name(params['host_id'])
       @host
     end
 
     def find_hostgroup
-      @hostgroup   = Hostgroup.find_by_id(params['hostgroup_id'].to_i) if params['hostgroup_id'].to_i > 0
-      @hostgroup ||= Hostgroup.find_by_name(params['hostgroup_id'])
+      @hostgroup   = Hostgroup.authorized(:view_hostgroups).find_by_id(params['hostgroup_id'].to_i) if params['hostgroup_id'].to_i > 0
+      @hostgroup ||= Hostgroup.authorized(:view_hostgroups).find_by_name(params['hostgroup_id'])
       @hostgroup
     end
 
     def find_smart_variable
       id = params.keys.include?('smart_variable_id') ? params['smart_variable_id'] : params['id']
-      @smart_variable   = LookupKey.smart_variables.find_by_id(id.to_i) if id.to_i > 0
+      @smart_variable   = LookupKey.authorized(:view_external_variables).smart_variables.find_by_id(id.to_i) if id.to_i > 0
       @smart_variable ||= (puppet_cond = { :puppetclass_id => @puppetclass.id } if @puppetclass
-                           LookupKey.smart_variables.where(puppet_cond).find_by_key(id)
+                           LookupKey.authorized(:view_external_variables).smart_variables.where(puppet_cond).find_by_key(id)
                           )
       @smart_variable
     end
@@ -81,19 +81,19 @@ module Api::V2::LookupKeysCommonController
     end
 
     def smart_variables_resource_scope
-      return LookupKey.smart_variables unless (@puppetclass || @host || @hostgroup)
+      return LookupKey.authorized(:view_external_variables).smart_variables unless (@puppetclass || @host || @hostgroup)
       puppetclass_ids   = @puppetclass.id if @puppetclass
       puppetclass_ids ||= @hostgroup.all_puppetclasses.map(&:id) if @hostgroup
       puppetclass_ids ||= @host.all_puppetclasses.map(&:id) if @host
-      LookupKey.global_parameters_for_class(puppetclass_ids)
+      LookupKey.authorized(:view_external_variables).global_parameters_for_class(puppetclass_ids)
     end
 
     def find_smart_class_parameter
       id = params.keys.include?('smart_class_parameter_id') ? params['smart_class_parameter_id'] : params['id']
-      @smart_class_parameter = LookupKey.smart_class_parameters.find_by_id(id.to_i) if id.to_i > 0
+      @smart_class_parameter = LookupKey.authorized(:view_external_variables).smart_class_parameters.find_by_id(id.to_i) if id.to_i > 0
       @smart_class_parameter ||= (puppet_cond = { 'environment_classes.puppetclass_id'=> @puppetclass.id } if @puppetclass
                                   env_cond = { 'environment_classes.environment_id' => @environment.id } if @environment
-                                  LookupKey.smart_class_parameters.where(puppet_cond).where(env_cond).where(:key => id).first
+                                  LookupKey.authorized(:view_external_variables).smart_class_parameters.where(puppet_cond).where(env_cond).where(:key => id).first
                                  )
       @smart_class_parameter
     end
@@ -103,20 +103,21 @@ module Api::V2::LookupKeysCommonController
     end
 
     def smart_class_parameters_resource_scope
-      return LookupKey.smart_class_parameters unless (@puppetclass || @environment || @host || @hostgroup)
+      base = LookupKey.authorized(:view_external_variables)
+      return base.smart_class_parameters unless (@puppetclass || @environment || @host || @hostgroup)
       if @puppetclass && @environment
-        LookupKey.smart_class_parameters_for_class(@puppetclass.id, @environment.id)
+        base.smart_class_parameters_for_class(@puppetclass.id, @environment.id)
       elsif @puppetclass && !@environment
         environment_ids = @puppetclass.environment_classes.pluck(:environment_id).uniq
-        LookupKey.smart_class_parameters_for_class(@puppetclass.id, environment_ids)
+        base.smart_class_parameters_for_class(@puppetclass.id, environment_ids)
       elsif !@puppetclass && @environment
         puppetclass_ids = @environment.environment_classes.pluck(:puppetclass_id).uniq
-        LookupKey.smart_class_parameters_for_class(puppetclass_ids, @environment.id)
+        base.smart_class_parameters_for_class(puppetclass_ids, @environment.id)
       elsif @host || @hostgroup
         puppetclass_ids = (@host || @hostgroup).all_puppetclasses.map(&:id)
         environment_id  = (@host || @hostgroup).environment_id
         # scope :parameters_for_class uses .override
-        LookupKey.parameters_for_class(puppetclass_ids, environment_id)
+        base.parameters_for_class(puppetclass_ids, environment_id)
       end
     end
 
diff --git a/app/controllers/concerns/api/v2/taxonomies_controller.rb b/app/controllers/concerns/api/v2/taxonomies_controller.rb
index e89cceb50..078054f4f 100644
--- a/app/controllers/concerns/api/v2/taxonomies_controller.rb
+++ b/app/controllers/concerns/api/v2/taxonomies_controller.rb
@@ -100,7 +100,7 @@ module Api::V2::TaxonomiesController
   end
 
   def allowed_nested_id
-    %w(domain_id compute_resource_id subnet_id environment_id hostgroup_id smart_proxy_id user_id medium_id organization_id location_id)
+    %w(domain_id compute_resource_id subnet_id environment_id hostgroup_id smart_proxy_id user_id medium_id organization_id location_id filter_id)
   end
 
 end
diff --git a/app/controllers/concerns/foreman/controller/taxonomies_controller.rb b/app/controllers/concerns/foreman/controller/taxonomies_controller.rb
index bb95515f4..825447b46 100644
--- a/app/controllers/concerns/foreman/controller/taxonomies_controller.rb
+++ b/app/controllers/concerns/foreman/controller/taxonomies_controller.rb
@@ -135,7 +135,7 @@ module Foreman::Controller::TaxonomiesController
 
   def assign_hosts
     @taxonomy_type = taxonomy_single.classify
-    @hosts = Host.my_hosts.send("no_#{taxonomy_single}").includes(included_associations).search_for(params[:search],:order => params[:order]).paginate(:page => params[:page])
+    @hosts = Host.authorized(:view_hosts, Host).send("no_#{taxonomy_single}").includes(included_associations).search_for(params[:search],:order => params[:order]).paginate(:page => params[:page])
     render "hosts/assign_hosts"
   end
 
diff --git a/app/controllers/concerns/foreman/controller/taxonomy_multiple.rb b/app/controllers/concerns/foreman/controller/taxonomy_multiple.rb
index 9f0316c5e..8f4b2b963 100644
--- a/app/controllers/concerns/foreman/controller/taxonomy_multiple.rb
+++ b/app/controllers/concerns/foreman/controller/taxonomy_multiple.rb
@@ -8,20 +8,20 @@ module Foreman::Controller::TaxonomyMultiple
   end
 
   def select_multiple_organization
-    find_multiple
+    @hosts = find_multiple
   end
 
   def select_multiple_location
-    find_multiple
+    @hosts = find_multiple
   end
 
   def update_multiple_organization
-    find_multiple
+    @hosts = find_multiple
     update_multiple_taxonomies(:organization)
   end
 
   def update_multiple_location
-    find_multiple
+    @hosts = find_multiple
     update_multiple_taxonomies(:location)
   end
 
@@ -53,4 +53,4 @@ module Foreman::Controller::TaxonomyMultiple
     redirect_back_or_to hosts_path
   end
 
-end
\ No newline at end of file
+end
diff --git a/app/controllers/concerns/foreman/controller/users_mixin.rb b/app/controllers/concerns/foreman/controller/users_mixin.rb
index 63def7983..e038b0037 100644
--- a/app/controllers/concerns/foreman/controller/users_mixin.rb
+++ b/app/controllers/concerns/foreman/controller/users_mixin.rb
@@ -13,7 +13,6 @@ module Foreman::Controller::UsersMixin
   end
 
   def clear_params_on_update
-    find_resource
     if params[:user]
       @admin = params[:user].has_key?(:admin) ? params[:user].delete(:admin) : nil
       # Remove keys for restricted variables when the user is editing their own account
@@ -44,4 +43,4 @@ module Foreman::Controller::UsersMixin
     sub_hg = Hostgroup.where(:id => hostgroup_ids).map(&:subtree).flatten.reject { |hg| hg.user_ids.include?(@user.id) }
     sub_hg.each { |hg| hg.users << @user }
   end
-end
\ No newline at end of file
+end
diff --git a/app/controllers/config_templates_controller.rb b/app/controllers/config_templates_controller.rb
index 2cc030e5d..e29a48139 100644
--- a/app/controllers/config_templates_controller.rb
+++ b/app/controllers/config_templates_controller.rb
@@ -2,12 +2,12 @@ class ConfigTemplatesController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
   include Foreman::Renderer
 
-  before_filter :find_by_id, :only => [:edit, :update, :destroy]
-  before_filter :load_history, :only => :edit
   before_filter :handle_template_upload, :only => [:create, :update]
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
+  before_filter :load_history, :only => :edit
 
   def index
-    @config_templates = ConfigTemplate.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page]).includes(:template_kind, :template_combinations => [:hostgroup, :environment])
+    @config_templates = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page]).includes(:template_kind, :template_combinations => [:hostgroup, :environment])
   end
 
   def new
@@ -72,7 +72,7 @@ class ConfigTemplatesController < ApplicationController
       :id => template.name, :hostgroup => hostgroup.name
   end
 
-  def find_by_id
-    @config_template = ConfigTemplate.find(params[:id])
+  def controller_permission
+    'templates'
   end
 end
diff --git a/app/controllers/domains_controller.rb b/app/controllers/domains_controller.rb
index 66fa9d662..619111b65 100644
--- a/app/controllers/domains_controller.rb
+++ b/app/controllers/domains_controller.rb
@@ -3,7 +3,7 @@ class DomainsController < ApplicationController
   before_filter :find_by_name, :only => %w{edit update destroy}
 
   def index
-    @domains = Domain.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @domains      = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
     @host_counter = Host.group(:domain_id).where(:domain_id => @domains.select(&:id)).count
   end
 
diff --git a/app/controllers/environments_controller.rb b/app/controllers/environments_controller.rb
index b62e75964..5fd5e0be4 100644
--- a/app/controllers/environments_controller.rb
+++ b/app/controllers/environments_controller.rb
@@ -5,7 +5,7 @@ class EnvironmentsController < ApplicationController
   before_filter :find_by_name, :only => %w{edit update destroy}
 
   def index
-    @environments = Environment.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @environments = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
     @host_counter = Host.group(:environment_id).where(:environment_id => @environments.select(&:id)).count
   end
 
diff --git a/app/controllers/fact_values_controller.rb b/app/controllers/fact_values_controller.rb
index 97ee081bd..65f441d01 100644
--- a/app/controllers/fact_values_controller.rb
+++ b/app/controllers/fact_values_controller.rb
@@ -4,11 +4,12 @@ class FactValuesController < ApplicationController
   before_filter :setup_search_options, :only => :index
 
   def index
+    base = resource_base.no_timestamp_facts
     begin
-      values = FactValue.my_facts.search_for(params[:search], :order => params[:order])
+      values = base.my_facts.search_for(params[:search], :order => params[:order])
     rescue => e
       error e.to_s
-      values = FactValue.search_for ""
+      values = base.search_for ""
     end
 
     conds = (original_search_parameter || '').split(/AND|OR/i)
@@ -26,4 +27,10 @@ class FactValuesController < ApplicationController
     @fact_values = values.no_timestamp_facts.required_fields.paginate :page => params[:page]
   end
 
+  private
+
+  def controller_permission
+    'facts'
+  end
+
 end
diff --git a/app/controllers/filters_controller.rb b/app/controllers/filters_controller.rb
new file mode 100644
index 000000000..8d52ad049
--- /dev/null
+++ b/app/controllers/filters_controller.rb
@@ -0,0 +1,80 @@
+class FiltersController < ApplicationController
+  include Foreman::Controller::AutoCompleteSearch
+
+  before_filter :find_role
+  before_filter :setup_search_options, :only => :index
+
+  def index
+    @filters = resource_base.includes(:role, :permissions).search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @roles_authorizer = Authorizer.new(User.current, :collection => @filters.map(&:role_id))
+  end
+
+  def new
+    @filter = resource_base.build
+  end
+
+  def create
+    @filter = Filter.new(params[:filter])
+    if @filter.save
+      process_success :success_redirect => filters_path(:role_id => @role)
+    else
+      process_error
+    end
+  end
+
+  def edit
+    @filter = resource_base.includes(:permissions).find(params[:id])
+  end
+
+  def update
+    @filter = resource_base.find(params[:id])
+    if @filter.update_attributes(params[:filter])
+      process_success :success_redirect => filters_path(:role_id => @role)
+    else
+      process_error
+    end
+  end
+
+  def destroy
+    @filter = resource_base.find(params[:id])
+    if @filter.destroy
+      process_success :success_redirect => filters_path(:role_id => @role)
+    else
+      process_error
+    end
+  end
+
+  protected
+
+  def find_role
+    @role = Role.find_by_id(role_id)
+  end
+
+  def resource_base
+    @resource_base ||= @role.present? ?
+        @role.filters.authorized(current_permission) :
+        Filter.scoped.authorized(current_permission)
+  end
+
+  def role_id
+    params[:role_id]
+  end
+
+  def setup_search_options
+    @original_search_parameter = params[:search]
+    params[:search] ||= ""
+    params.keys.each do |param|
+      if param =~ /role_id$/
+        unless (role = Role.find_by_id(params[param])).blank?
+          query = "role = \"#{role.name}\""
+          params[:search] += query unless params[:search].include? query
+        end
+      elsif param =~ /(\w+)_id$/
+        unless params[param].blank?
+          query = "#{$1} = #{params[param]}"
+          params[:search] += query unless params[:search].include? query
+        end
+      end
+    end
+  end
+end
diff --git a/app/controllers/hostgroups_controller.rb b/app/controllers/hostgroups_controller.rb
index 24588e653..b0a7ab282 100644
--- a/app/controllers/hostgroups_controller.rb
+++ b/app/controllers/hostgroups_controller.rb
@@ -1,11 +1,10 @@
 class HostgroupsController < ApplicationController
   include Foreman::Controller::HostDetails
   include Foreman::Controller::AutoCompleteSearch
-
-  before_filter :find_hostgroup, :only => [:edit, :update, :destroy, :clone]
+  before_filter :find_by_name, :only => [:nest, :clone, :edit, :update, :destroy]
 
   def index
-    @hostgroups = Hostgroup.my_groups.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @hostgroups = resource_base.search_for(params[:search], :order => params[:order]).paginate :page => params[:page]
   end
 
   def new
@@ -13,7 +12,7 @@ class HostgroupsController < ApplicationController
   end
 
   def nest
-    @parent = Hostgroup.find(params[:id])
+    @parent = @hostgroup
     @hostgroup = Hostgroup.new(:parent_id => @parent.id)
 
     load_vars_for_ajax
@@ -56,8 +55,6 @@ class HostgroupsController < ApplicationController
   end
 
   def edit
-    auth  = User.current.admin? ? true : Hostgroup.my_groups.include?(@hostgroup)
-    not_found and return unless auth
     load_vars_for_ajax
   end
 
@@ -96,7 +93,7 @@ class HostgroupsController < ApplicationController
 
   def process_hostgroup
 
-    @parent = Hostgroup.find(params[:hostgroup][:parent_id]) if params[:hostgroup][:parent_id].to_i > 0
+    @parent = Hostgroup.authorized(:view_hostgroups).find(params[:hostgroup][:parent_id]) if params[:hostgroup][:parent_id].to_i > 0
     return head(:not_found) unless @parent
 
     @hostgroup = Hostgroup.new(params[:hostgroup])
@@ -117,10 +114,6 @@ class HostgroupsController < ApplicationController
 
   private
 
-  def find_hostgroup
-    @hostgroup = Hostgroup.find(params[:id])
-  end
-
   def load_vars_for_ajax
     return unless @hostgroup
     @architecture    = @hostgroup.architecture
@@ -140,4 +133,13 @@ class HostgroupsController < ApplicationController
     User.where(:subscribe_to_all_hostgroups => true)
   end
 
+  def action_permission
+    case params[:action]
+      when 'nest', 'clone'
+        'view'
+      else
+        super
+    end
+  end
+
 end
